


/*
 *  Dr Geo an interactive geometry software
 * (C) Copyright Hilaire Fernandes  1997-1998
 * hilaire.fernandes@iname.com 
 * 
 *
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public Licences as by published
 * by the Free Software Foundation; either version 2; or (at your option)
 * any later version
 *
 * This program is distributed in the hope that it will entertaining,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILTY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Publis License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef complex_h
#define complex_h

class Complex
{
  public:
  Complex (void)
  {
  }
  Complex (double x, double y)
  {
    r = x;
    i = y;
  }
  double r, i;
};

Complex operator *(Complex z, double k);
Complex operator *(double k, Complex z);
Complex operator / (Complex z, double k);
Complex operator / (double k, Complex z);
Complex operator *(Complex z1, Complex z2);
Complex operator + (Complex z1, Complex z2);
Complex operator - (Complex z1, Complex z2);
Complex operator / (Complex z1, Complex z2);
double imag (Complex z);
double real (Complex z);
Complex conj (Complex z);

#endif
